#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

void affiche_tab(int* tab, int taille, char* alpha)
{
	for (int i = 0; i < taille; ++i)
	{
		printf("nb de %c  = %d\n",alpha[i], tab[i] );
	}
}

double somme(int* tab, int total, int taille)
{
	double result = 0.0;
	double tmp;
	for (int i = 0; i < taille; ++i)
	{
        if (tab[i] != 0)
        {
            tmp = (double)tab[i]/(double)total;
            result = result + (tmp*log2(tmp));
        }
	}

	return -result;
}

void entropie_binaire(char *nomFichier)
{
    char lettre;
    FILE *fic = fopen(nomFichier, "r");
    int total = 0;
    int symboles[2] = {0};
    printf("affichage de %s : \n", nomFichier);
    while((lettre = fgetc(fic)) != EOF)
    {
        total++;
        printf("%c\n", lettre);
        switch(lettre)
        {
            case '0':
                symboles[0] ++;
                break;
            case '1' :
                symboles[1] ++;
                break;
            default :
                printf("fichier non binaire");
                exit(0);
                break;
        }
    }
    fclose(fic);
    printf("entropie de %s : %f",nomFichier, somme(symboles,total, 2));

}

void entropie( char *nomFichier)
{
    char lettre;
    FILE *fic = fopen(nomFichier, "r");
    int total_symbole = 0;
    int symboles[28] = {0};
    char* alphabet = "abcdefghijklmnopqrstuvwxyz ";
    int pres = 0;


/*Tant que le fichier n'est pas fini on regarde le caractère courant et on augmente son nombre d'occurences, si le caractère 
n'est pas une lettre non-accentuée ou un espace on incremente le nombre de caractères spéciaux */
    while( (lettre = fgetc(fic)) != EOF)
	{
		pres = 0;
		total_symbole++;
			for (int i = 0; i < strlen(alphabet); i++)
			{

				if (alphabet[i] == lettre || alphabet[i] ==tolower(lettre))
				{
					symboles[i]++;
					pres = 1;
				}
			}
			if (pres == 0)
			{
				symboles[27]++;
			}
	}
	fclose(fic);
	printf("%d %d\n", total_symbole, symboles[27]);

	/* on veut calculer une probabilité, donc pour calculer le cardinal de l'ensemble on enlève le nombre de symboles pas pris
	en compte */
	total_symbole -= symboles[27];
	printf("%d\n", total_symbole);
	affiche_tab(symboles, 27, alphabet);
	printf("entropie de %s: %f\n\n\n\n",nomFichier,somme(symboles,total_symbole, 27));



}


int main(int argc, char const *argv[])
{
    entropie("test.txt");
    entropie("entropie_fr.txt");
    entropie("entropie_eng.txt");
    entropie_binaire("binaire.txt");
	return 0;
}
